% inner loop (Step 2) of DLC Algorithm
function [LctRec,ModeMtx] = ILDLC(X,ModeMtx,K,DistW,NumVal,LctRec)
[Pm.Xlth,Pm.Xwd]=size(X); % fetch statistics of data set
Pm.k=K;
Change=1; % set convergence judger for launching loop
Loop=0;
while Change==1 && Loop<=50 % iteratively assign data objects to appropriate clusters until convergence
    Change=0;
    Loop=Loop+1;
    for i=1:Pm.Xlth
        DistVec=zeros(Pm.k,1);
        for j=1:Pm.k
            SubDist=zeros(1,Pm.Xwd);        
            for h=1:Pm.Xwd
                SubSubDist=zeros(1,NumVal(h));
                for m=1:NumVal(h)
                    if X(i,h)~=m
                        SubSubDist(m)=sum(DistW{h}(min(X(i,h),m):max(X(i,h),m)-1))*ModeMtx{j,h}(m);
                    end
                end
                % SubDist(h)=sum(SubSubDist); % for the case that each attribute has same number of categories
                SubDist(h)=sum(SubSubDist)/(NumVal(h)-1); % for the case that attributes are with different number of categories
            end
            DistVec(j)=sum(SubDist);
        end
        [~,Winner]=min(DistVec);
        if LctRec(i)~=Winner
            Change=1;
            LctRec(i)=Winner;
        end
    end
    for i=1:Pm.k % update ModeMtx for the next loop
        ClusterLth=length(find(LctRec==i));
        if sum(LctRec==i)>0
            for j=1:Pm.Xwd
                for h=1:NumVal(j)
                    ModeMtx{i,j}(h)=length(find(X(LctRec==i,j)==h))/ClusterLth;
                end
            end
        end
    end
end
